-- Copyright © 2012 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.
-- Current distribution permissions only include curse.com, wowui.worldofwar.net, wowinterface.com and their respective addon updaters

local _, MonkTimers = ...

local SpellIDs = MonkTimers.SpellIDs
local SpellTextures = MonkTimers.SpellTextures
local SpellNames = MonkTimers.SpellNames
local AvailableSpells = MonkTimers.AvailableSpells
local TigerPalmBuff = SpellNames[SpellIDs.PowerGuard]

local cds = {}
--local spells = {SpellNames[SpellIDs.StormStrike], SpellNames[SpellIDs.EarthShock], SpellNames[SpellIDs.LavaLash], SpellNames[SpellIDs.FlameShock]}
local playerName = UnitName("player")
local role = 1

local num_CD_Spells = {[1]=3,[2]=1,[3]=1,}
MonkTimers.num_CD_Spells = num_CD_Spells

local function NoUpdate()
end


local CD_Spells = {
    [1] = {
        [1] = SpellIDs.TigerPalm,
        [2] = SpellIDs.BlackoutKick,
        [3] = SpellIDs.ElusiveBrew,
    },
    [2] = {
        [1] = SpellIDs.TigerPalm,

    },
    [3] = {
        [1] = SpellIDs.TigerPalm,
    },
}

MonkTimers.CD_Spells = CD_Spells

local function ActivateCD(self)
    XiTimers.Activate(self)
end

   
local function ChangeTimerOrder(self,spell)
    if InCombatLockdown() then return end
    if not spell then return end
    local _,spell1 = GetSpellBookItemInfo(spell, "BOOKTYPE_SPELL")
    local spell2 = self:GetAttribute("orderspell")    
    if not spell2 or not spell1 then return end
    local spellnum1, spellnum2 = nil,nil
    for i=1,num_CD_Spells[role] do
        if CD_Spells[role][i] == spell1 then spellnum1 = i end
        if CD_Spells[role][i] == spell2 then spellnum2 = i end        
    end
    if not spellnum1 or not spellnum2 then return end
    local order1, order2 = nil
    for i=1,#MonkTimers.ActiveProfile.Timer_Order[role] do
        if MonkTimers.ActiveProfile.Timer_Order[role][i] == spellnum1 then order1 = i end
        if MonkTimers.ActiveProfile.Timer_Order[role][i] == spellnum2 then order2 = i end
    end
    if not order1 or not order2 then return end
    MonkTimers.ActiveProfile.Timer_Order[role][order1], MonkTimers.ActiveProfile.Timer_Order[role][order2] =
        MonkTimers.ActiveProfile.Timer_Order[role][order2], MonkTimers.ActiveProfile.Timer_Order[role][order1]
    MonkTimers.LayoutTimers()
end
   
function MonkTimers.CreateTimers()
    for i = 1,10 do
        cds[i] = XiTimers:new(1)
        cds[i].events[1] = "SPELL_UPDATE_COOLDOWN"
        cds[i].dontFlash = true
        cds[i].timeStyle = "sec"
        cds[i].button.anchorframe = MonkTimersFrame
        cds[i].button:SetAttribute("*type*", "spell")
        --cds[i].activate = ActivateCD
        cds[i].reverseAlpha = true
        --cds[i].dontAlpha = true
        cds[i].button.icons[1]:SetAlpha(1)
        cds[i].button:SetScript("OnEvent", MonkTimers.TimerEvents)
        cds[i].button:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp")
    end


    for i=1,10 do
        cds[i].button:SetAttribute("_ondragstart",[[if IsShiftKeyDown() and self:GetAttribute("orderspell")~=0 then
                                                    return "spell", self:GetAttribute("orderspell")
                                              else control:CallMethod("StartMove") end]])
        cds[i].button:SetAttribute("_onreceivedrag",[[ if kind == "spell" then
                                                   control:CallMethod("ChangeTimerOrder", value, ...)
                                                    return "clear"
                                              end]])
        cds[i].button.ChangeTimerOrder = ChangeTimerOrder
    end
end

local ElusiveBrewEvent
local TigerPalmEvent
local BlackoutKickEvent

function MonkTimers.ConfigTimers() 
    role = GetSpecialization()
    if not role then role = 1 end
   
    
    for i=1,10 do
        cds[i]:Deactivate()
    end
    
    if not MonkTimers.ActiveProfile.Timers then return end

    for i=1,num_CD_Spells[role] do
        cds[i].button.cdspell = CD_Spells[role][i]
        cds[i].button.icons[1]:SetTexture(SpellTextures[CD_Spells[role][i]])
        cds[i].button:SetAttribute("*spell1", SpellNames[CD_Spells[role][i]])
        cds[i].RangeCheck = SpellNames[CD_Spells[role][i]]
        cds[i].ManaCheck = SpellNames[CD_Spells[role][i]]
        cds[i].button:SetScript("OnEvent", MonkTimers.TimerEvents)
        cds[i].Update = nil
        cds[i].prohibitCooldown = false
        cds[i].button:SetAttribute("orderspell", CD_Spells[role][i])
        cds[i].events = {"SPELL_UPDATE_COOLDOWN"}
        cds[i].barTimerOnly = false
        cds[i].reverseAlpha = false
        cds[i].button.bar:SetStatusBarColor(0.6,0.6,1,0.7)
    end
    
    cds[1].prohibitCooldown = true
    cds[1].button:SetScript("OnEvent", TigerPalmEvent)
    cds[1].events[1] = "UNIT_AURA"
    cds[1].barTimerOnly = true
    cds[1].reverseAlpha = true
    
    cds[2].events[1] = "UNIT_AURA"
    cds[2].button:SetScript("OnEvent", BlackoutKickEvent)
    cds[2].reverseAlpha = true
    
    if role == 1 then
        TigerPalmBuff = SpellNames[SpellIDs.PowerGuard]
        cds[3].events[1] = "UNIT_AURA"
        cds[3].button:SetScript("OnEvent", ElusiveBrewEvent)
    elseif role == 2 then
        TigerPalmBuff = SpellNames[SpellIDs.TigerPower]
    else
    end
    
    for i=1,num_CD_Spells[role] do
        if MonkTimers.ActiveProfile.Timer_Spells[role][i] and AvailableSpells[CD_Spells[role][MonkTimers.ActiveProfile.Timer_Order[role][i]]] then
            cds[i]:Activate()
        end
    end
end

local active_cds = {}

local function ConvertCoords(frame1, frame2)
    return frame1:GetEffectiveScale()/frame2:GetEffectiveScale()
end


function MonkTimers.LayoutTimers()
    wipe(active_cds)
    for i=1,num_CD_Spells[role] do
        if cds[MonkTimers.ActiveProfile.Timer_Order[role][i]].active then
            table.insert(active_cds,cds[MonkTimers.ActiveProfile.Timer_Order[role][i]])
        end
    end
    for i=1,1 do 
        cds[i]:ClearAnchors()
        cds[i].button:ClearAllPoints()
    end
    local xmove, xmovebottom = 0, 0
    local fsreltop = nil
    local fsrelbottom = nil
    if #active_cds == 0 then
       --[[ if cds[9].active then
            cds[9].button:SetPoint("TOPRIGHT", MonkTimersFrame)
        else
            cds[9].button:SetPoint("BOTTOMRIGHT", MonkTimersFrame)
        end
        if cds[10].active then
            cds[10].button:SetPoint("BOTTOM", MonkTimersFrame)
        end]]
    elseif #active_cds == 1 then
        active_cds[1].button:SetPoint("CENTER", MonkTimersFrame)
        fsreltop = active_cds[1].button
        fsrelbottom = active_cds[1].button
        xmovetop = -(MonkTimers.ActiveProfile.TimerSize*3.5+5)
        xmovebottom = -(MonkTimers.ActiveProfile.TimerSize*3.5+5)
    elseif #active_cds == 2 then
        active_cds[1].button:SetPoint("RIGHT", MonkTimersFrame, "CENTER", -3, 0)
        active_cds[2]:Anchor(active_cds[1], "LEFT")
        fsreltop = active_cds[1].button
        fsrelbottom = active_cds[1].button
        xmovetop = -(MonkTimers.ActiveProfile.TimerSize*2.5+5)
        xmovebottom = -(MonkTimers.ActiveProfile.TimerSize*2.5+5)
    elseif #active_cds == 3 then
        active_cds[2].button:SetPoint("CENTER", MonkTimersFrame)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        fsreltop = active_cds[1].button
        fsrelbottom = active_cds[1].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 4 then 
        active_cds[2].button:SetPoint("RIGHT", MonkTimersFrame, -3, 0)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        xmovebottom = (MonkTimers.ActiveProfile.TimerSize*0.5+5)
        xmovetop = 0
        fsreltop = cds[1].button
        fsrelbottom = cds[1].button
    elseif #active_cds == 5 then
        active_cds[1].button:SetPoint("RIGHT", MonkTimersFrame, "CENTER", -3, 0)
        active_cds[2]:Anchor(active_cds[1], "LEFT")
        active_cds[3]:Anchor(active_cds[1], "TOPRIGHT", "BOTTOM", true)
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[5]:Anchor(active_cds[4], "LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 6 then
        active_cds[2].button:SetPoint("CENTER", MonkTimersFrame)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[5]:Anchor(active_cds[2], "TOP", "BOTTOM")
        active_cds[4]:Anchor(active_cds[5],"RIGHT")
        active_cds[6]:Anchor(active_cds[5],"LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 7 then
        active_cds[2].button:SetPoint("CENTER", MonkTimersFrame)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[5]:Anchor(active_cds[2], "TOPRIGHT", "BOTTOM", true)
        active_cds[4]:Anchor(active_cds[5], "RIGHT")
        active_cds[6]:Anchor(active_cds[5], "LEFT")
        active_cds[7]:Anchor(active_cds[6], "LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 8 then
        active_cds[2].button:SetPoint("RIGHT", MonkTimersFrame, -3, 0)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[5]:Anchor(active_cds[1], "TOP", "BOTTOM")
        active_cds[6]:Anchor(active_cds[2], "TOP", "BOTTOM")
        active_cds[7]:Anchor(active_cds[3], "TOP", "BOTTOM")
        active_cds[8]:Anchor(active_cds[4], "TOP", "BOTTOM")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 9 then
        active_cds[2].button:SetPoint("RIGHT", MonkTimersFrame, -3, 0)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[6]:Anchor(active_cds[2], "TOPRIGHT", "BOTTOM", true)
        active_cds[5]:Anchor(active_cds[6], "RIGHT")
        active_cds[7]:Anchor(active_cds[6], "LEFT")
        active_cds[8]:Anchor(active_cds[7], "LEFT")
        active_cds[9]:Anchor(active_cds[8], "LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 10 then
        active_cds[3].button:SetPoint("CENTER", MonkTimersFrame)
        active_cds[2]:Anchor(active_cds[3], "RIGHT")
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[5]:Anchor(active_cds[4], "LEFT")
        active_cds[6]:Anchor(active_cds[1], "TOP", "BOTTOM")
        active_cds[7]:Anchor(active_cds[2], "TOP", "BOTTOM")
        active_cds[8]:Anchor(active_cds[3], "TOP", "BOTTOM")
        active_cds[9]:Anchor(active_cds[4], "TOP", "BOTTOM")
        active_cds[10]:Anchor(active_cds[5], "TOP", "BOTTOM")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 11 then
        active_cds[3].button:SetPoint("CENTER", MonkTimersFrame)
        active_cds[2]:Anchor(active_cds[3], "RIGHT")
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[5]:Anchor(active_cds[4], "LEFT")
        active_cds[6]:Anchor(active_cds[1], "TOPRIGHT", "BOTTOM", true)
        active_cds[7]:Anchor(active_cds[6], "LEFT")
        active_cds[8]:Anchor(active_cds[7], "LEFT")
        active_cds[9]:Anchor(active_cds[8], "LEFT")
        active_cds[10]:Anchor(active_cds[9], "LEFT")
        active_cds[11]:Anchor(active_cds[10], "LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0 
    end
end

function MonkTimers.ActivateTimers()
    MonkTimers.ConfigTimers()
    MonkTimers.LayoutTimers()
end

function MonkTimers.DeactivateTimers()
    for k,v in pairs(cds) do
        v:Deactivate()
    end
end

function MonkTimers.TimerEvents(self, event, ...)
    local settings = MonkTimers.ActiveProfile
    if event == "SPELL_UPDATE_COOLDOWN" and AvailableSpells[self.cdspell] then 
        local start, duration, enable = GetSpellCooldown(self.cdspell)
        if (not start and not duration) or (duration <= 1.5 and not InCombatLockdown()) then
            self.timer:Stop(1)					
        else
            if duration == 0 then
                self.timer:Stop(1)
            elseif duration > 2 and self.timer.timers[1]<=0 then
                self.timer:Start(1,start+duration-floor(GetTime()),duration)
            end
            CooldownFrame_SetTimer(self.cooldown, start, duration, enable)
        end 
    end
end

TigerPalmEvent = function(self, event, unit)
    if event == "UNIT_AURA" then
        if unit == "player" then
            local _,_,_,count,_,duration, expiration = UnitBuff("player", TigerPalmBuff)
            if count and count > 0 then
                self.timer:Start(1, count)
                self.timer:StartBarTimer(expiration-GetTime(), duration)
            elseif self.timer.timers[1]>0 then
                self.timer:Stop(1)
            end
        end
    end
end


local Shuffle = SpellNames[SpellIDs.Shuffle]

BlackoutKickEvent = function(self, event, unit)
    if event == "UNIT_AURA" then
        if unit == "player" then
            local _,_,_,count,_,duration, expiration = UnitBuff("player", Shuffle)
            if duration and duration > 0 then
                self.timer:Start(1, expiration-GetTime(), duration)
            elseif self.timer.timers[1]>0 then
                self.timer:Stop(1)
            end
        end
     end
end


local ElusiveBrewStacks = SpellNames[SpellIDs.ElusiveBrewStacks]
local ElusiveBrewBuff = SpellNames[SpellIDs.ElusiveBrewBuff]
local StackTexture = SpellTextures[SpellIDs.ElusiveBrewStacks]
local BuffTexture = SpellTextures[SpellIDs.ElusiveBrewBuff]

ElusiveBrewEvent = function(self, event, unit)
    if unit == "player" then
        local _,_,_,count,_,duration,expiration = UnitBuff("player", ElusiveBrewStacks)
        local _,_,_,_,_,buffduration,buffexpiration = UnitBuff("player", ElusiveBrewBuff)
        if buffduration and buffduration < 30 then
            self.timer.prohibitCooldown = false
            self.icon:SetTexture(BuffTexture)
            self.timer:StopBarTimer()
            self.timer.barTimerOnly = false
            self.timer:Start(1, buffexpiration-GetTime(), buffduration)            
        elseif count and count > 0 then
            self.timer.prohibitCooldown = true
            self.timer.barTimerOnly = true
            self.icon:SetTexture(StackTexture)
            self.timer:StartBarTimer(expiration-GetTime(), duration)
            self.timer:Start(1, count)
        else
            if self.timer.timers[1] > 0 then
                self.timer:Stop(1)
            end
            if self.timer.barTimer > 0 then
                self.timer:StopBarTimer()
            end
        end 
    end
end





